//+------------------------------------------------------------------+
//|                                              Pretty_t3_LK_V1.mq4 |
//|                         Orginal T3 calculation by Tim Tillson in |
//|     Technical Analysis of Stocks and Commodities - January 1998. |
//|                     Source code Copyright  2009, Leif Karlsson. |
//|                                        Leffemannen1973@telia.com |
//+------------------------------------------------------------------+
//| Please feel free to copy, modify and / or redistribute this      |
//| software / source code in any way you see fit.                   |
//+------------------------------------------------------------------+
//+ ********************* Shameless Ad. **************************** +
//+ * I do custom programing jobs in Java, C, X86 Assembler & MQL4 * +
//+ ***** Pleace do not hesitate to get in contact if you nead ***** +
//+ ***** something special: EA, indicator or somthing else. ******* +
//+ ****************** Leffemannen1973@telia.com ******************* +
//+ **************************************************************** +
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Leif Karlsson"
#property link      "mailto://Leffemannen1973@telia.com"
//+------------------------------------------------------------------+
#property  indicator_chart_window
#property  indicator_buffers 1
//+------------------------------------------------------------------+
extern int T3Period = 9;
extern double T3Amp = 1.0;
extern string AppliedPriceText1 = "Close: 0, Open: 1, High: 2, Low: 3";
extern string AppliedPriceText2 = "Median: 4, Typical: 5, Weighted: 6";
extern int AppliedPrice = 4;
extern int PriceShift = 0;
extern int MaxBars = 1000;
//+------------------------------------------------------------------+
double c1;
double c2;
double c3;
double c4;

double t3[];
double p1[];
double p2[];
double p3[];
double p4[];
double p5[];
double p6[];

double Alpha;

string IndiName;
bool FirstRun;
datetime LastTime = 0;
//+------------------------------------------------------------------+
int deinit() {

	int i = MaxBars;
	while(i >= 0) {
		ObjectDelete(IndiName + " " + i);
		i--;
	}
	return(0);
}
//+------------------------------------------------------------------+
int init() {
   	
	ArrayResize(t3, MaxBars+2);   		
	ArrayResize(p1, MaxBars+2);
	ArrayResize(p2, MaxBars+2);
	ArrayResize(p3, MaxBars+2);
	ArrayResize(p4, MaxBars+2);
	ArrayResize(p5, MaxBars+2);
	ArrayResize(p6, MaxBars+2);
		
	ArraySetAsSeries(t3, true);		
	ArraySetAsSeries(p1, true);
	ArraySetAsSeries(p2, true);
	ArraySetAsSeries(p3, true);
	ArraySetAsSeries(p4, true);
	ArraySetAsSeries(p5, true);
	ArraySetAsSeries(p6, true); 
	
	IndiName = "T3, T3Period: " + T3Period + ", T3Amp: " + T3Amp + " ";
   	IndicatorShortName(IndiName);
   	
   	Alpha = 2.0/(T3Period + 1.0);  
   	
   	double a = T3Amp;
   	c1 = -a*a*a;
	c2 = 3.0*a*a+3.0*a*a*a;
	c3 = -6.0*a*a-3.0*a-3.0*a*a*a;
	c4 = 1.0+3.0*a+a*a*a+3.0*a*a;

	FirstRun = true;
   	 	
   	return(0);
}
//+------------------------------------------------------------------+
void Draw(double Val[], int i, color c) {

	static int oi = 0;
	oi = (oi+1) % MaxBars;
	
	string ObjName = IndiName + " " + oi;
	
      ObjectDelete(ObjName);
      ObjectCreate(ObjName, OBJ_TREND, 0, Time[i+1], Val[i+1], Time[i], Val[i]);
      ObjectSet(ObjName, OBJPROP_RAY, false);
      ObjectSet(ObjName, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(ObjName, OBJPROP_COLOR, c);        
      ObjectSet(ObjName, OBJPROP_WIDTH, 2);
}
//+------------------------------------------------------------------+
int start() {

	int i = IndicatorCounted();
	if(i < 0) return(-1);
	i = Bars - i;
	if(i > MaxBars) i = MaxBars;
	if(FirstRun || i == MaxBars) {
		FirstRun = false;
		LastTime = Time[0];
				
		p1[i+1] = iMA(NULL, 0, 1, 0, 0, AppliedPrice, i+PriceShift+1);
		p2[i+1] = p1[i+1];
		p3[i+1] = p1[i+1];
		p4[i+1] = p1[i+1];
		p5[i+1] = p1[i+1];
		p6[i+1] = p1[i+1];
		t3[i+1] = p1[i+1];
	} 
	else {
		int j = ArrayBsearch(Time, LastTime, MaxBars, 0, MODE_DESCEND);
		if(j > 0) {
			ArrayCopy(t3, t3, j, 0, MaxBars);
			ArrayCopy(p1, p1, j, 0, MaxBars);
			ArrayCopy(p2, p2, j, 0, MaxBars);
			ArrayCopy(p3, p3, j, 0, MaxBars);
			ArrayCopy(p4, p4, j, 0, MaxBars);
			ArrayCopy(p5, p5, j, 0, MaxBars);
			ArrayCopy(p6, p6, j, 0, MaxBars);
			j--;
		}
		LastTime = Time[0];
	}
					
	while(i >= 0) {
		
		double p0 = iMA(NULL, 0, 1, 0, 0, AppliedPrice, i+PriceShift);				
		p1[i] = p1[i+1] + Alpha*(p0 - p1[i+1]);
		p2[i] = p2[i+1] + Alpha*(p1[i] - p2[i+1]);
		p3[i] = p3[i+1] + Alpha*(p2[i] - p3[i+1]);
		p4[i] = p4[i+1] + Alpha*(p3[i] - p4[i+1]);
		p5[i] = p5[i+1] + Alpha*(p4[i] - p5[i+1]);
		p6[i] = p6[i+1] + Alpha*(p5[i] - p6[i+1]);
						
		t3[i] = c1*p6[i] + c2*p5[i] + c3*p4[i] + c4*p3[i];
		
		double g = (t3[i]-t3[i+1])/iATR(NULL, 0, T3Period, i);
		int b = 127 + 127*((1-MathExp(-3.5*g))/(1+MathExp(-3.5*g)));
		int r = 127 - 127*((1-MathExp(-3.5*g))/(1+MathExp(-3.5*g)));
		
		Draw(t3, i, b << 16 + r);
						
		i--;
	}	

   	return(0);
}

